      SUBROUTINE FACTR( N, A, IP, NDIM)
C     SUBROUTINE TO FACTOR A MATRIX INTO A UNIT LOWER TRIANGULAR MATRIX
C     AND AN UPPER TRIANGULAR MATRIX USING THE GAUSS-DOOLITTLE ALGORITHM
C     PRESENTED ON PAGES 411-416 OF A. RALSTON--A FIRST COURSE IN
C     NUMERICAL ANALYSIS.  COMMENTS BELOW REFER TO COMMENTS IN RALSTONS
C     TEXT.    (MATRIX TRANSPOSED.
C
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      COMPLEX*16  A,D, ARJ
      DIMENSION  A( NDIM, NDIM), IP( NDIM)
      COMMON  /SCRATM/ D(NM)
      IFLG=0
C
C     STEP 1
C
      DO 9  IR=1, N
      DO 1  K=1, N
      D( K)= A( IR, K)
C
C     STEPS 2 AND 3
C
    1 CONTINUE
      IRM1= IR-1
      IF( IRM1.LT.1) GOTO 4
      DO 3  J=1, IRM1
      IPJ= IP( J)
      ARJ= D( IPJ)
      A( IR, J)= ARJ
      D( IPJ)= D( J)
      JP1= J+1
      DO 2  I= JP1, N
      D( I)= D( I)- A( J, I)* ARJ
    2 CONTINUE
    3 CONTINUE
C
C     STEP 4
C
    4 CONTINUE
      DMAX= DBLE( D( IR)* CONJG( D( IR)))
      IP( IR)= IR
      IRP1= IR+1
      IF( IRP1.GT. N) GOTO 6
      DO 5  I= IRP1, N
      ELMAG= DBLE( D( I)* CONJG( D( I)))
      IF( ELMAG.LT. DMAX) GOTO 5
      DMAX= ELMAG
      IP( IR)= I
    5 CONTINUE
    6 CONTINUE
      IF( DMAX.LT.1.D-10) IFLG=1
      IPR= IP( IR)
      A( IR, IR)= D( IPR)
C
C     STEP 5
C
      D( IPR)= D( IR)
      IF( IRP1.GT. N) GOTO 8
      ARJ=1/ A( IR, IR)
      DO 7  I= IRP1, N
      A( IR, I)= D( I)* ARJ
    7 CONTINUE
    8 CONTINUE
      IF( IFLG.EQ.0) GOTO 9
      WRITE(*,10)  IR, DMAX
      IFLG=0
    9 CONTINUE
C
      RETURN
   10 FORMAT(1H ,'PIVOT(',I3,')=',1P,E16.8)
      END
