      SUBROUTINE HELIX( S, HL, A1, B1, A2, B2, RAD, NS, ITG)
C     SUBROUTINE HELIX GENERATES SEGMENT GEOMETRY DATA FOR A HELIX OF NS
C     SEGMENTS
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      DIMENSION  X2(1), Y2(1), XZ2(1)
      EQUIVALENCE(X2(1),SI(1)),(Y2(1),ALP(1)),(XZ2(1),BET(1))
      DATA   PI/3.141592653589793D0/
      IST= N+1
      N= N+ NS
      NP= N
      IPSYM=0
      IF( NS.LT.1) RETURN
      RZINC= ABS( HL/ NS)
      RXZ( IST)=0.
      IF(N.GT.NM)GOTO 944
      DO 25  I= IST, N
      BI( I)= RAD
      ITAG( I)= ITG
      IF( I.NE. IST) RXZ( I)= RXZ( I-1)+ RZINC
      XZ2( I)= RXZ( I)+ RZINC
      IF( A2.NE. A1) GOTO 10
      IF( B1.EQ.0) B1= A1
      X( I)= A1* COS(2.* PI* RXZ( I)/ S)
      Y( I)= B1* SIN(2.* PI* RXZ( I)/ S)
      X2( I)= A1* COS(2.* PI* XZ2( I)/ S)
      Y2( I)= B1* SIN(2.* PI* XZ2( I)/ S)
      GOTO 20
   10 IF( B2.EQ.0) B2= A2
      X(I)=(A1+(A2-A1)*RXZ(I)/ABS(HL))*COS(2.*PI*RXZ(I)/S)
      Y(I)=(B1+(B2-B1)*RXZ(I)/ABS(HL))*SIN(2.*PI*RXZ(I)/S)
      X2(I)=(A1+( A2- A1)* XZ2( I)/ ABS( HL))* COS(2.* PI* XZ2( I)/ S)
      Y2(I)=(B1+( B2- B1)* XZ2( I)/ ABS( HL))* SIN(2.* PI* XZ2( I)/ S)
   20 IF( HL.GT.0) GOTO 25
      COPY= X( I)
      X( I)= Y( I)
      Y( I)= COPY
      COPY= X2( I)
      X2( I)= Y2( I)
      Y2( I)= COPY
   25 CONTINUE
      IF( A2.EQ. A1) GOTO 21
      SANGLE= ATAN( A2/( ABS( HL)+( ABS( HL)* A1)/( A2- A1)))
      WRITE(*,104)  SANGLE
  104 FORMAT(' **END HELIX**  CONE ANGLE OF SPIRAL =',F10.4)
      RETURN
   21 IF( A1.NE. B1) GOTO 30
      HDIA=2.* A1
      TURN= HDIA* PI
      PITCH= ATAN( S/( PI* HDIA))
      TURN= TURN/ COS( PITCH)
      PITCH=180.* PITCH/ PI
      GOTO 40
   30 IF( A1.LT. B1) GOTO 34
      HMAJ=2.* A1
      HMIN=2.* B1
      GOTO 35
   34 HMAJ=2.* B1
      HMIN=2.* A1
   35 HDIA= SQRT(( HMAJ**2+ HMIN**2)/2* HMAJ)
      TURN=2.* PI* HDIA
      PITCH=(180./ PI)* ATAN( S/( PI* HDIA))
   40 WRITE( *,105)  PITCH, TURN
  105 FORMAT(' **END HELIX**  PITCH ANGLE =',F10.4,
     &'   LENGTH OF WIRE/TURN =',F10.4)
      RETURN
 944  WRITE(*,*)'HELIX:too many segments NM',N,NM
      END
