      SUBROUTINE RDPAT
C     COMPUTE RADIATION PATTERN, GAIN, NORMALIZNED GAIN
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      DIMENSION ETHR(2),EPHR(2)
      INCLUDE 'data.inc'
      INCLUDE 'cntrl.inc'
      INCLUDE 'minim.inc'
      INCLUDE 'fpat.inc'
      COMMON  /SCRATM/FLT(NQUMAX)
      COMMON/PTDAT/PHX,PHY,ROZ,THZ,ZTH,ZPH
      EQUIVALENCE (ZTH,ETHR(1)),(ZPH,EPHR(1))
      DATA   PI/3.141592653589793D0/
      DATA   CONST/29.97922085D+0/
      DATA TA/1.745329252D-02/
      IF(NPPRT.EQ.0.OR.NPPRT.GT.3)GOTO 3255
      OPEN ( UNIT=45,FILE='PATTERN.NEC')
      WRITE(*,*)'Radiation pattern listed in PATTERN.NEC'
      IF(NPPRT.EQ.1)WRITE(45,622)
 622  FORMAT(15X,' Theta=0',/,6X,'Phi        POWER          Db')
      IF(NPPRT.EQ.2)WRITE(45,624)
 624  FORMAT(6X,'Phi     Theta        POWER          Db')
      IF(NPPRT.EQ.3)WRITE(45,626)
 626  FORMAT(6X,'Phi    POWER 0 to Phi')
 3255 CONTINUE
      IF(NPPRT.EQ.4)THEN
        OPEN ( UNIT=65,FILE='RESULT.NEC')
        OPEN ( UNIT=66,FILE='FARFIELD.NEC')
        WRITE(*,*)'Result listed (No optimisation)'
        NPPRT=5
      ENDIF
      GCOP= WLAM* WLAM*2.* PI/(376.73* PINR)
      PRAD= PINR- PLOSS- PNLR
C Get field and gain in the forward direction
      PHA=0
      ROZ=COS(PHA)
      THZ=-SIN(PHA)
      THA=0
      PHX=- SIN( THA)
      PHY= COS( THA)
      CALL FFLD
      P1=ETHR(1)*ETHR(1)+ETHR(2)*ETHR(2)
      P2=EPHR(1)*EPHR(1)+EPHR(2)*EPHR(2)
      FWD0= DBLE( P1+P2 )
      IF(NPPRT.EQ.5)THEN
      T1=ATAN2(ETHR(1),ETHR(2))/TA
      T2=ATAN2(EPHR(1),EPHR(2))/TA
      WRITE(*,630)FMHZ,100*P1/FWD0,T1,100*P2/FWD0,T2
      WRITE(66,630)FMHZ,100*P1/FWD0,T1,100*P2/FWD0,T2
 630  FORMAT(' ',F11.3,2(F9.4,'%',F9.2,'deg   '))
      ENDIF
      GTOT= DB10( GCOP*FWD0*CONST**2)
      FWD=FWD0*PRAD/PINR
      TFWD=0
      TSIDE=0
      TBCK=0
C Integrate radiation pattern to get gain.
C Divide the arc PHI to 180 degrees in NPH steps.
C Make PHA point at the midpoint of each division
      TMP1=(180-PHIS)*TA
      PHSTEP=TMP1/NPH
      PHA=PHIS*TA-PHSTEP/2
      WFAC=PI/(2*FWD*NPH)
C**
 2139 DO 29  KPH=1, NPH
      PHA= PHA+PHSTEP
      ST=SIN(PHA)
      ROZ=COS(PHA)
      SFWD=0
      SSIDE=0
      SBCK=0
      THZ=-ST
C Divide the arc 0 to THETS into NTH*ST steps, but make sure to not
C make NTHST=0 at any KPH which would cause incorrect gain.
      TMP1=THETS*TA
      NTHST=1+(NTH-1)*ST
      THSTEP=TMP1/NTHST
      THA=-THSTEP/2
      SQST=SQRT(ST*WFAC/NTHST)
C----------------------
      DO 39  KTH=1, NTHST
      THA= THA+THSTEP
      PHX=-SIN( THA)
      PHY= COS( THA)
      CALL FFLD
      IF(NPPRT.EQ.2)GOTO 139
      GOTO 239
  139 RELFAR=(DBLE(ZTH*CONJG(ZTH)) + DBLE(ZPH*CONJG(ZPH)))/FWD0
      WRITE(45,612)PHA/TA,THA/TA,RELFAR,DB10(RELFAR)
 612  format(2f10.2,f14.6,F14.3)
  239 CONTINUE
      ZTH=ZTH*SQST
      ZPH=ZPH*SQST

      NQU=NQU+4
      IF(NQU.GT.NQUMAX)GOTO 932
C Get a better G/T (gain over temperature) by putting more
C weight on the field in case we point into the ground.
C As is customary we assume the antenna is elevated by 30 degrees.
C Zero to THETS is the range of angles we study rotating around the boom
C axis if the antenna is a yagi.
C Elements along Y-axis are vertically polarised.
C pha=angle off boom.  tha=angle around boom
C tha=0, pha=90 is towards horizon.
C st=sin(pha)  phy=cos(tha)
      G1=ST*PHY+ROZ*0.5774
      G2=-ST*PHY+ROZ*0.5774
      IF(G1*G2.LT.0)THEN
        SSIDE=SSIDE+DBLE(ZTH*CONJG(ZTH)) + DBLE(ZPH*CONJG(ZPH))
        FLT(NQU-3)=ETHR(1)*(1+0.5*GTWEI)
        FLT(NQU-2)=ETHR(2)*(1+0.5*GTWEI)
        FLT(NQU-1)=EPHR(1)*(1+0.5*GTWEI)
        FLT(NQU  )=EPHR(2)*(1+0.5*GTWEI)
      ELSE
      IF(G1.GT.0.AND.G2.GT.0)THEN
        SFWD=SFWD+DBLE(ZTH*CONJG(ZTH)) + DBLE(ZPH*CONJG(ZPH))
        FLT(NQU-3)=ETHR(1)
        FLT(NQU-2)=ETHR(2)
        FLT(NQU-1)=EPHR(1)
        FLT(NQU  )=EPHR(2)
        ELSE
        SBCK=SBCK+DBLE(ZTH*CONJG(ZTH)) + DBLE(ZPH*CONJG(ZPH))
        FLT(NQU-3)=ETHR(1)*(1+GTWEI)
        FLT(NQU-2)=ETHR(2)*(1+GTWEI)
        FLT(NQU-1)=EPHR(1)*(1+GTWEI)
        FLT(NQU  )=EPHR(2)*(1+GTWEI)
        ENDIF
      ENDIF
      IF(NPPRT.EQ.5)NQU=NQU-4
   39 CONTINUE

      TFWD=TFWD+SFWD
      TSIDE=TSIDE+SSIDE
      TBCK=TBCK+SBCK
      IF(NPPRT.EQ.0)GOTO 29
      IF(NPPRT.EQ.3)WRITE(45,600)PHA/TA,100*(TFWD+TSIDE+TBCK)
C----------------------
      IF(NPPRT.NE.1)GOTO 29
      PHX=0
      PHY=1
      CALL FFLD
      FARFLD=DBLE(ZTH*CONJG(ZTH)) + DBLE(ZPH*CONJG(ZPH))
      WRITE(45,600)PHA/TA,FARFLD/FWD0,DB10(FARFLD/FWD0)
 600  format(f10.2,f14.6,F14.3)
   29 CONTINUE
      GAI=1/(TFWD+TSIDE+TBCK)
C The commonly accepted G/T value is based on different temperatures
C for the 3 regions we integrated over.
      TANT=(TFWD*TSKY+0.5*TSIDE*(TSKY+TGND)+TBCK*TGND)*GAI
      GDBPAT=DB10(GAI)
      TANT=100*(TANT+(100-EFFIC)*2.90)/EFFIC
      TDB=DB10(TANT)
      GOVERT=GDBPAT-TDB
      IF(BCKWEI.EQ.0)RETURN
      NQU=NQU+1
      IF(NQU.GT.NQUMAX)GOTO 932
      PHA=PI
      ROZ=COS(PHA)
      THZ=-SIN(PHA)
      THA=0
      PHX=- SIN( THA)
      PHY= COS( THA)
      CALL FFLD
      FARFLD=DBLE(ZTH*CONJG(ZTH)) + DBLE(ZPH*CONJG(ZPH))
      FLT(NQU  )=BCKWEI*SQRT(FARFLD/(FWD0*NPH))

C
      RETURN
 932  WRITE(*,*)'TOO MANY EQUATIONS NQUMAX AT ANGLE',PHA/TA,' DEGREES'
      STOP
      END
